import type { LineEncodeChannels, SemanticTooltipOption, WithDefaultEncode, BasicEncoderSpecMap, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, CrosshairSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class Line extends SemanticMark<BasicEncoderSpecMap['line'], LineEncodeChannels> {
    static readonly type = PlotMakType.line;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['line'], LineEncodeChannels>, LineEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: LineEncodeChannels, option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['line'], LineEncodeChannels>, LineEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    convertMarkEncode(encode: WithDefaultEncode<BasicEncoderSpecMap['line'], LineEncodeChannels>): GenerateBaseEncodeSpec<BasicEncoderSpecMap['line']>;
}
